--images
background = Image.load ("images/background2.png")
light = Image.load ("images/light2.png")

blood1 = Image.load ("images/sang/blood1.png")
blood2 = Image.load ("images/sang/blood2.png")
blood3 = Image.load ("images/sang/blood3.png")
blood4 = Image.load ("images/sang/blood4.png")
blood5 = Image.load ("images/sang/blood5.png")

cote = Image.load ("images/cote.png")

--couleur
vert = Color.new(0,255,0)
rouge = Color.new(255,0,0)
noir = Color.new(0,0,0)
bleu = Color.new(255,0,0)
blanc = Color.new(255,255,255)

--player
player = {
present = true,
hauteur = 34,
largeur = 32,
y = 200,
x = 480/2,
gravity = 200,
jumpspeed = 10,
jumpstate = "sol",
img = playerdroite1,
vie = 100,
direction = "droite",
marche = false,
timer = 0,
energie = 100,
rage = 0,
vitesse = 5,
degatS = 0
}

--enemie
monstre = {}
monstreder = 3
for a = 1,monstreder do
monstre[a] = {present=true,
posX=math.random(20,450),
posY=200,
destX=math.random(20,450),
destY=200,
largeur=32,
hauteur=32,
direction="droite",
timerattack = 0,
vie =100,
saut = false,
gravity = 200,
jumpspeed = 10,
jumpstate = "sol",
vitesse = 0.25,
type = 1,
sangtimer = 0
}
monstreLeft = Image.load("images/personnages/monstre".. monstre[a].type .."/monsterleft.png")
monstreRight = Image.load("images/personnages/monstre".. monstre[a].type .."/monsterright.png")
monstre[a].img = monstreRight
end

score = 0
timer = 0
timeratt = 0

X = 0
Y = 0

--Les vecteurs 
--      v : dplacement ; f : vitesse ponctuelle ; p : poids 
v = {x=0, y=0} 
p = {x=0, y=0.1} 
f = {x=0, y=0} 

ratio = 512      --ration rgle la sensibilit du joystick 
inertie = 0.02      --taux d'inertie pour aller de + en + vite 
dec = 0.08      --taux de ralentissement 

bleu = Color.new(0, 0, 255) 
blanc = Color.new(255, 255, 255) 
noir = Color.new(0, 0, 0) 
px, py = 0, 0 

function sign(v)      --retourne le signe d'une variable (1 ou -1) 
   return math.abs(v)/v 
end 

--Boucle Principal
while true do
pad = Controls.read() 
screen:clear()

px = pad:analogX()
py = pad:analogY()

if player.rage <= 99.9 and player.rage >= 0 then
player.rage = player.rage -0.1
end
if player.rage >=100 then
player.rage = 100
end
if player.energie <=100 then
player.energie = player.energie +0.1
end
if player.energie <=0 then
player.energie = 0
end

if px < -10 then
player.direction = "gauche"
end
if px > 10 then
player.direction = "droite"
end

if(math.abs(px) > 40) then 
f.x = px/ratio + v.x*inertie*sign(px) 
v.x = v.x + f.x 
else 
v.x = v.x - v.x*dec 
if(math.abs(v.x)<0.1) then v.x = 0 end 
end 
if(math.abs(py) > 40) then 
f.y = py/ratio + v.y*inertie*sign(py) 
v.y = v.y + f.y 
else 
v.y = v.y - v.y*dec 
if(math.abs(v.y)<0.1) then v.y = 0 end 
end 
if v.x >= player.vitesse then
v.x=player.vitesse
end
if v.x <= -player.vitesse then
v.x=-player.vitesse
end
if v.x > 1.5 or v.x < -1.5 then
player.marche = true
end
if v.x >= -1.4 and v.x <= 1.4 then
player.marche = false
end

screen:blit (X,Y,background)

--enemie
for a = 1,monstreder do
if monstre[a].posX <=0 then
monstre[a].destX = 450
monstre[a].posX = 1
end
if monstre[a].posX >=480-monstre[a].largeur then
monstre[a].destX = 20
monstre[a].posX = 480-monstre[a].largeur-1
end
if monstre[a].saut == true then
monstre[a].vitesse =3
end
if monstre[a].saut == false then
monstre[a].vitesse =0.25
end
if monstre[a].saut == true and monstre[a].jumpstate == "sol" then 
monstre[a].jumpstate = "en saut" 
end
if monstre[a].jumpstate == "en saut" then 
monstre[a].jumpspeed = monstre[a].jumpspeed - 0.5
monstre[a].gravity = monstre[a].gravity - monstre[a].jumpspeed 
end
if monstre[a].gravity < 0 then 
monstre[a].jumpstate = "retombe"
end
if monstre[a].gravity < 200 and monstre[a].jumpstate == "retombe" then 
monstre[a].gravity = monstre[a].gravity + (monstre[a].jumpspeed + 3) 
end
if monstre[a].posY >= 200-monstre[a].hauteur and monstre[a].gravity > 200 then 
monstre[a].jumpspeed = 10
monstre[a].jumpstate = "sol"
monstre[a].posY = 200-monstre[a].hauteur
monstre[a].gravity = 200
monstre[a].saut = false
end
monstre[a].posY = monstre[a].gravity

if monstre[a].present == true then
screen:fillRect(monstre[a].posX+X+15,monstre[a].posY+Y,100/5,20/6,blanc)
screen:fillRect(monstre[a].posX+X+15,monstre[a].posY+Y,monstre[a].vie/5,20/6,rouge)
screen:blit(monstre[a].posX+X,monstre[a].posY+Y,monstre[a].img)

if monstre[a].direction == "droite" then
monstre[a].img = monstreRight
end
if monstre[a].direction == "gauche" then
monstre[a].img = monstreLeft
end
if monstre[a].posX< monstre[a].destX then monstre[a].direction = "droite" monstre[a].marche = true monstre[a].posX = monstre[a].posX+X +monstre[a].vitesse end
if monstre[a].posX> monstre[a].destX then monstre[a].direction = "gauche" monstre[a].marche = true monstre[a].posX = monstre[a].posX+X -monstre[a].vitesse end
monstre[a].marche = false
if monstre[a].posX == monstre[a].destX then
monstre[a].destX = math.random(20,440)
end
if monstre[a].sang == true then
monstre[a].sangtimer = monstre[a].sangtimer+6
if monstre[a].sangtimer >= 0 and monstre[a].sangtimer <= 20 then screen:blit(monstre[a].posXA+4,monstre[a].posYA+2,blood1) end
if monstre[a].sangtimer > 20 and monstre[a].sangtimer <= 40 then screen:blit(monstre[a].posXA,monstre[a].posYA+4,blood2) end
if monstre[a].sangtimer > 40 and monstre[a].sangtimer <= 60 then screen:blit(monstre[a].posXA+4,monstre[a].posYA+6,blood3) end
if monstre[a].sangtimer > 60 and monstre[a].sangtimer <= 80 then screen:blit(monstre[a].posXA,monstre[a].posYA+8,blood4) end
if monstre[a].sangtimer > 80 and monstre[a].sangtimer <= 100 then screen:blit(monstre[a].posXA+4,monstre[a].posYA+10,blood5) end
if monstre[a].sangtimer > 100 then monstre[a].sangtimer = 0 monstre[a].sang = false end
end
if (player.x +X+player.largeur > monstre[a].posX+X  ) and (player.x +X < monstre[a].posX+X  +monstre[a].largeur ) and (player.y +Y  +player.hauteur > monstre[a].posY+Y  ) and (player.y +Y< monstre[a].posY+Y  +monstre[a].hauteur ) then
if player.statut == "attaque" and player.jumpstate == "sol" then
monstre[a].posXA = monstre[a].posX+X
monstre[a].posYA = monstre[a].posY+Y
monstre[a].sang = true 
if player.marche == true or pad:r() and player.jumpstate == "en saut" or pad:r() and player.jumpstate == "retombe" then 
if player.direction == "droite" then
if player.jumpstate == "sol" then
monstre[a].saut = true
end
monstre[a].vie = monstre[a].vie -v.x-player.degatS
player.rage = player.rage +v.x/a
monstre[a].destX = monstre[a].posX+X +v.x*100
end
if player.direction == "gauche" then
if player.jumpstate == "sol" then
monstre[a].saut = true
end
monstre[a].vie = monstre[a].vie +v.x-player.degatS
player.rage = player.rage -v.x/a
monstre[a].destX = monstre[a].posX+X +v.x*100
end
end
if player.marche == false then 
monstre[a].vie = monstre[a].vie -4-player.degatS
player.rage = player.rage +4/a
if player.direction == "droite" then
if player.jumpstate == "sol" then
monstre[a].saut = true
end
monstre[a].destX = monstre[a].posX+X +78
end
if player.direction == "gauche" then
if player.jumpstate == "sol" then
monstre[a].saut = true
end
monstre[a].destX = monstre[a].posX+X -78
end
end
end
end
end
if monstre[a].vie <= 1 and monstre[a].present == true then
monstre[a].vie = 0
monstre[a].posXA = monstre[a].posX+X
monstre[a].posYA = monstre[a].posY+Y
monstre[a].sangtimer = monstre[a].sangtimer+6
if monstre[a].sangtimer >= 340 and monstre[a].sangtimer <= 360 then screen:blit(monstre[a].posXA+4-5,monstre[a].posYA+2-5,blood1) end
if monstre[a].sangtimer > 360 and monstre[a].sangtimer <= 380 then screen:blit(monstre[a].posXA-5,monstre[a].posYA+4-5,blood2) end
if monstre[a].sangtimer > 380 and monstre[a].sangtimer <= 400 then screen:blit(monstre[a].posXA+4-5,monstre[a].posYA+6-5,blood3) end
if monstre[a].sangtimer > 400 and monstre[a].sangtimer <= 420 then screen:blit(monstre[a].posXA-5,monstre[a].posYA+8-5,blood4) end
if monstre[a].sangtimer > 420 and monstre[a].sangtimer <= 440 then screen:blit(monstre[a].posXA+4-5,monstre[a].posYA+10-5,blood5) end
if monstre[a].sangtimer > 440 then monstre[a].sangtimer = 0 monstre[a].present = false monstre[a].sang = false end
end
end

--deplacement de la carte

if player.x <=0 then
player.x = 1
v.x = 0
end
if player.x >=480-player.largeur then
player.x = 480-player.largeur-1
v.x = 0
end

--fonction du saut
if pad:cross() and player.jumpstate == "sol" then player.jumpstate = "en saut" end
if player.jumpstate == "en saut" then 
player.jumpspeed = player.jumpspeed - 0.5
player.gravity = player.gravity - player.jumpspeed 
end
if player.gravity < 0 then 
player.jumpstate = "retombe"
end
if player.gravity < 200 and player.jumpstate == "retombe" then 
player.gravity = player.gravity + (player.jumpspeed + 3) 
end
if player.y >= 200-player.hauteur and player.gravity > 200 then 
player.jumpspeed = 10
player.jumpstate = "sol"
player.y = 200-player.hauteur
player.gravity = 200
end
player.y = player.gravity

--attaque 
if player.statut == "attaque" then
player.largeur = 73
end
player.largeur = 33
if pad:r() and player.marche == true then
player.statut = "attaque"
if player.statut == "attaque" then
if player.direction=="gauche" then 
player.timer = player.timer-v.x
if player.timer >=0 and player.timer <=20 then player.img = moveplayerattgauche1 end
if player.timer >20 and player.timer <=40 then player.img = moveplayerattgauche2 end
if player.timer >40 and player.timer <=60 then player.img = moveplayerattgauche4 end 
if player.timer >60 and player.timer <=80 then player.img = moveplayerattgauche3 end 
if player.timer >80 and player.timer <=100 then player.img = moveplayerattgauche1 end 
if player.timer >100 then player.timer = 0 end
end
if player.direction=="droite" then 
player.timer = player.timer+v.x
if player.timer >=0 and player.timer <=20 then player.img = moveplayerattdroite1 end
if player.timer >20 and player.timer <=40 then player.img = moveplayerattdroite2 end
if player.timer >40 and player.timer <=60 then player.img = moveplayerattdroite4 end 
if player.timer >60 and player.timer <=80 then player.img = moveplayerattdroite3 end 
if player.timer >80 and player.timer <=100 then player.img = moveplayerattdroite1 end 
if player.timer >100 then player.timer = 0 end
end
end 
end
if pad:r() and player.marche == false or pad:r() and player.jumpstate == "en saut" or pad:r() and player.jumpstate == "retombe" then
player.statut = "attaque"
if player.statut == "attaque" then
if player.direction=="gauche" then 
player.timer = player.timer+8
if player.timer >=0 and player.timer <=20 then player.img = playerattgauche1 end
if player.timer >20 and player.timer <=40 then player.img = playerattgauche2 end
if player.timer >40 and player.timer <=60 then player.img = playerattgauche3 end 
if player.timer >60 and player.timer <=80 then player.img = playerattgauche4 end
if player.timer >80 and player.timer <=100 then player.img = playerattgauche5 end
if player.timer >100 and player.timer <=120-5 then player.img = playerattgauche6 end
if player.timer >120-5 and player.timer <=140-10 then player.img = playerattgauche5 end
if player.timer >140-10 and player.timer <=160-15 then player.img = playerattgauche4 end
if player.timer >160-15 and player.timer <=180-20 then player.img = playerattgauche3 end 
if player.timer >180-20 and player.timer <=200-25 then player.img = playerattgauche2 end
if player.timer >200-25 and player.timer <=220-30 then player.img = playerattgauche1 end
if player.timer >220-30 then player.timer = 0 end
end
if player.direction=="droite" then 
player.timer = player.timer+8
if player.timer >=0 and player.timer <=20 then player.img = playerattdroite1 end
if player.timer >20 and player.timer <=40 then player.img = playerattdroite2 end
if player.timer >40 and player.timer <=60 then player.img = playerattdroite3 end 
if player.timer >60 and player.timer <=80 then player.img = playerattdroite4 end
if player.timer >80 and player.timer <=100 then player.img = playerattdroite5 end
if player.timer >100 and player.timer <=120-5 then player.img = playerattdroite6 end
if player.timer >120-5 and player.timer <=140-10 then player.img = playerattdroite5 end
if player.timer >140-10 and player.timer <=160-15 then player.img = playerattdroite4 end
if player.timer >160-15 and player.timer <=180-20 then player.img = playerattdroite3 end 
if player.timer >180-20 and player.timer <=200-25 then player.img = playerattdroite2 end
if player.timer >200-25 and player.timer <=220-30 then player.img = playerattdroite1 end
if player.timer >220-30 then player.timer = 0 end
end
end
end
--defense
if pad:l() and v.x >=-0.5 and v.x <=0.5 then
player.statut = "defense"
if player.statut == "defense" and v.x >=-0.5 and v.x <=0.5 then
if player.jumpstate == "sol" then
v.x = 0
end
if player.direction=="gauche" then 
player.img = playerdefgauche             
end
 if player.direction=="droite" then 
player.img = playerdefdroite
end
end 
end

if not pad:r() and not pad:l() then 
player.statut = "false"
end

--Dplacement 
if player.statut ~= "defense" and player.jumpstate == "sol" or player.jumpstate == "en saut" or player.jumpstate == "retombe" then
player.x = player.x +v.x
end

--player
if player.marche == true and player.statut == "false" then
if player.direction=="gauche" then 
player.timer = player.timer-v.x
if player.timer >=0 and player.timer <=20 then player.img = playergauche1 end
if player.timer >20 and player.timer <=40 then player.img = playergauche2 end
if player.timer >40 and player.timer <=60 then player.img = playergauche4 end 
if player.timer >60 and player.timer <=80 then player.img = playergauche3 end 
if player.timer >80 and player.timer <=100 then player.img = playergauche1 end 
if player.timer >100 then player.timer = 0 end
end
if player.direction=="droite" then 
player.timer = player.timer+v.x
if player.timer >=0 and player.timer <=20 then player.img = playerdroite1 end
if player.timer >20 and player.timer <=40 then player.img = playerdroite2 end
if player.timer >40 and player.timer <=60 then player.img = playerdroite4 end 
if player.timer >60 and player.timer <=80 then player.img = playerdroite3 end 
if player.timer >80 and player.timer <=100 then player.img = playerdroite1 end 
if player.timer >100 then player.timer = 0 end
end
end
if player.marche == false and player.statut == "false" then
if player.direction=="gauche" then 
player.img = playergauche4          
end
if player.direction=="droite" then 
player.img = playerdroite4
end
end

player.vitesse = 4

if player.energie <=0 then
player.vitesse = 2
end
if pad:square() and player.energie >=0 then
if player.direction=="gauche" then 
player.energie = player.energie +v.x/6
end
if player.direction=="droite" then 
player.energie = player.energie -v.x/6
end
if player.energie >0 then
player.vitesse = 8
end
end

if player.rage >= 100 then
degatS = 2
player.energie = 100
timeratt = timeratt+0.01
X = math.random(-5,5)
Y = math.random(-5,5)
end
if timeratt >= 13 then
player.rage = player.rage-2
player.energie = player.energie-3
if player.rage <=0 then
timeratt = 0
end
end
if player.rage < 100 then
degatS = 0
X = 0
Y = 0
end

screen:blit(player.x+X,player.y+Y,player.img) 
screen:blit(X,Y,light)
screen:blit(X,Y,cote)

for a = 1,3 do
nuage[a].x = nuage[a].x+1+math.random(-0.2,1)
if nuage[a].x+272 >= 0 and nuage[a].x <= 480 then  
screen:blit (nuage[a].x,nuage[a].y,nua)
end
if nuage[a].x >=480+272 then
nuage[a].y = math.random(0,200-72)
nuage[a].x = 0-272
end
end

screen:fillRect(10+X,10+Y,100,20,blanc)
screen:fillRect(10+X,10+20+10+Y,100,20,blanc)
screen:fillRect(10+X,10+20+10+20+10+Y,100,20,blanc)

screen:fillRect(10+X,10+Y,player.vie,20,vert)
screen:fillRect(10+X,10+20+10+Y,player.rage,20,rouge)
screen:fillRect(10+X,10+20+10+20+10+Y,player.energie,20,bleu)

screen:print(10+50-5+X,10+5+Y,"Vie",noir)
screen:print(10+50-10+X,10+20+10+5+Y,"Rage",noir)
screen:print(10+50-20+X,10+20+10+20+10+5+Y,"Energie",noir)

if pad:start() then dofile("game.lua") end

collectgarbage()

oldpad = pad
screen.flip()
--screen.waitVblankStart()
screen:clear()
end

logo = nil