System.usbDiskModeActivate()

--images
background = Image.load ("images/background1.png")
light = Image.load ("images/light1.png")
nua = Image.load ("images/nua.png")

--droite
playerdroite1 = Image.load ("images/personnages/player/moveright/1.png")
playerdroite2 = Image.load ("images/personnages/player/moveright/2.png")
playerdroite3 = Image.load ("images/personnages/player/moveright/3.png")
playerdroite4 = Image.load ("images/personnages/player/moveright/4.png")

moveplayerattdroite1 = Image.load ("images/personnages/player/moveATTright/1.png")
moveplayerattdroite2 = Image.load ("images/personnages/player/moveATTright/2.png")
moveplayerattdroite3 = Image.load ("images/personnages/player/moveATTright/3.png")
moveplayerattdroite4 = Image.load ("images/personnages/player/moveATTright/4.png")

playerattdroite1 = Image.load ("images/personnages/player/ATTright/1.png")
playerattdroite2 = Image.load ("images/personnages/player/ATTright/2.png")
playerattdroite3 = Image.load ("images/personnages/player/ATTright/3.png")
playerattdroite4 = Image.load ("images/personnages/player/ATTright/4.png")
playerattdroite5 = Image.load ("images/personnages/player/ATTright/5.png")
playerattdroite6 = Image.load ("images/personnages/player/ATTright/6.png")

--gauche
playergauche1 = Image.load ("images/personnages/player/moveleft/1.png")
playergauche2 = Image.load ("images/personnages/player/moveleft/2.png")
playergauche3 = Image.load ("images/personnages/player/moveleft/3.png")
playergauche4 = Image.load ("images/personnages/player/moveleft/4.png")

moveplayerattgauche1 = Image.load ("images/personnages/player/moveATTleft/1.png")
moveplayerattgauche2 = Image.load ("images/personnages/player/moveATTleft/2.png")
moveplayerattgauche3 = Image.load ("images/personnages/player/moveATTleft/3.png")
moveplayerattgauche4 = Image.load ("images/personnages/player/moveATTleft/4.png")

playerattgauche1 = Image.load ("images/personnages/player/ATTleft/1.png")
playerattgauche2 = Image.load ("images/personnages/player/ATTleft/2.png")
playerattgauche3 = Image.load ("images/personnages/player/ATTleft/3.png")
playerattgauche4 = Image.load ("images/personnages/player/ATTleft/4.png")
playerattgauche5 = Image.load ("images/personnages/player/ATTleft/5.png")
playerattgauche6 = Image.load ("images/personnages/player/ATTleft/6.png")

--def
playerdefdroite = Image.load ("images/personnages/player/DEF/playerdefright.png")
playerdefgauche = Image.load ("images/personnages/player/DEF/playerdefleft.png")

logo = Image.load ("images/logo.png")
cote = Image.load ("images/cote.png")

--couleur
vert = Color.new(0,255,0)
rouge = Color.new(255,0,0)
noir = Color.new(0,0,0)
bleu = Color.new(255,0,0)
blanc = Color.new(255,255,255)

--player
player = {
present = true,
hauteur = 34,
largeur = 32,
y = 200,
x = 480/2,
gravity = 200,
jumpspeed = 10,
jumpstate = "sol",
img = playerdroite1,
vie = 100,
direction = "droite",
marche = false,
timer = 0,
energie = 100,
rage = 0,
vitesse = 4
}

nuage = {}
for a = 1,3 do
nuage[a] = {
x = math.random(0-272,480),
y = math.random(0,200-72)
}
end

score = 0
timer = 0

bouton = {}
bouton[1] = {x = 480/2-100/2,y = 272/2,largeur = 100,txt = "start",color = blanc}

--Les vecteurs 
--      v : dplacement ; f : vitesse ponctuelle ; p : poids 
v = {x=0, y=0} 
p = {x=0, y=0.1} 
f = {x=0, y=0} 

ratio = 512      --ration rgle la sensibilit du joystick 
inertie = 0.01      --taux d'inertie pour aller de + en + vite 
dec = 0.08      --taux de ralentissement 

bleu = Color.new(0, 0, 255) 
blanc = Color.new(255, 255, 255) 
noir = Color.new(0, 0, 0) 
px, py = 0, 0 

function sign(v)      --retourne le signe d'une variable (1 ou -1) 
   return math.abs(v)/v 
end 

--Boucle Principal
while true do
pad = Controls.read() 
screen:clear()

px = pad:analogX()
py = pad:analogY()

if player.rage <= 99.9 and player.rage >= 0 then
player.rage = player.rage -0.1
end
if player.rage >=100 then
player.rage = 100
end
if player.energie <=100 then
player.energie = player.energie +0.1
end
if player.energie <=0 then
player.energie = 0
end

if px < -10 then
player.direction = "gauche"
end
if px > 10 then
player.direction = "droite"
end

if(math.abs(px) > 40) then 
f.x = px/ratio + v.x*inertie*sign(px) 
v.x = v.x + f.x 
else 
v.x = v.x - v.x*dec 
if(math.abs(v.x)<0.1) then v.x = 0 end 
end 
if(math.abs(py) > 40) then 
f.y = py/ratio + v.y*inertie*sign(py) 
v.y = v.y + f.y 
else 
v.y = v.y - v.y*dec 
if(math.abs(v.y)<0.1) then v.y = 0 end 
end 
if v.x >= player.vitesse then
v.x=player.vitesse
end
if v.x <= -player.vitesse then
v.x=-player.vitesse
end
if v.x > 0.75 or v.x < -0.75 then
player.marche = true
end
if v.x >= -0.74 and v.x <= 0.74 then
player.marche = false
end

screen:blit (0,0,background)
screen:blit(480/2-344/2,272/2-105/2-50,logo)

--deplacement de la carte

if player.x <=0 then
player.x = 1
v.x = 0
end
if player.x >=480-player.largeur then
player.x = 480-player.largeur-1
v.x = 0
end

--fonction du saut
if pad:cross() and player.jumpstate == "sol" then player.jumpstate = "en saut" end
if player.jumpstate == "en saut" then 
player.jumpspeed = player.jumpspeed - 0.5
player.gravity = player.gravity - player.jumpspeed 
end
if player.gravity < 0 then 
player.jumpstate = "retombe"
end
if player.gravity < 200 and player.jumpstate == "retombe" then 
player.gravity = player.gravity + (player.jumpspeed + 3) 
end
if player.y >= 200-player.hauteur and player.gravity > 200 then 
player.jumpspeed = 10
player.jumpstate = "sol"
player.y = 200-player.hauteur
player.gravity = 200
end
player.y = player.gravity

--attaque 
if player.statut == "attaque" then
player.largeur = 73
end
player.largeur = 33
if pad:r() and player.marche == true then
player.statut = "attaque"
if player.statut == "attaque" then
if player.direction=="gauche" then 
player.timer = player.timer-v.x
if player.timer >=0 and player.timer <=20 then player.img = moveplayerattgauche1 end
if player.timer >20 and player.timer <=40 then player.img = moveplayerattgauche2 end
if player.timer >40 and player.timer <=60 then player.img = moveplayerattgauche4 end 
if player.timer >60 and player.timer <=80 then player.img = moveplayerattgauche3 end 
if player.timer >80 and player.timer <=100 then player.img = moveplayerattgauche1 end 
if player.timer >100 then player.timer = 0 end
end
if player.direction=="droite" then 
player.timer = player.timer+v.x
if player.timer >=0 and player.timer <=20 then player.img = moveplayerattdroite1 end
if player.timer >20 and player.timer <=40 then player.img = moveplayerattdroite2 end
if player.timer >40 and player.timer <=60 then player.img = moveplayerattdroite4 end 
if player.timer >60 and player.timer <=80 then player.img = moveplayerattdroite3 end 
if player.timer >80 and player.timer <=100 then player.img = moveplayerattdroite1 end 
if player.timer >100 then player.timer = 0 end
end
end 
end
if pad:r() and player.marche == false or pad:r() and player.jumpstate == "en saut" or pad:r() and player.jumpstate == "retombe" then
player.statut = "attaque"
if player.statut == "attaque" then
if player.direction=="gauche" then 
player.timer = player.timer+8
if player.timer >=0 and player.timer <=20 then player.img = playerattgauche1 end
if player.timer >20 and player.timer <=40 then player.img = playerattgauche2 end
if player.timer >40 and player.timer <=60 then player.img = playerattgauche3 end 
if player.timer >60 and player.timer <=80 then player.img = playerattgauche4 end
if player.timer >80 and player.timer <=100 then player.img = playerattgauche5 end
if player.timer >100 and player.timer <=120-5 then player.img = playerattgauche6 end
if player.timer >120-5 and player.timer <=140-10 then player.img = playerattgauche5 end
if player.timer >140-10 and player.timer <=160-15 then player.img = playerattgauche4 end
if player.timer >160-15 and player.timer <=180-20 then player.img = playerattgauche3 end 
if player.timer >180-20 and player.timer <=200-25 then player.img = playerattgauche2 end
if player.timer >200-25 and player.timer <=220-30 then player.img = playerattgauche1 end
if player.timer >220-30 then player.timer = 0 end
end
if player.direction=="droite" then 
player.timer = player.timer+8
if player.timer >=0 and player.timer <=20 then player.img = playerattdroite1 end
if player.timer >20 and player.timer <=40 then player.img = playerattdroite2 end
if player.timer >40 and player.timer <=60 then player.img = playerattdroite3 end 
if player.timer >60 and player.timer <=80 then player.img = playerattdroite4 end
if player.timer >80 and player.timer <=100 then player.img = playerattdroite5 end
if player.timer >100 and player.timer <=120-5 then player.img = playerattdroite6 end
if player.timer >120-5 and player.timer <=140-10 then player.img = playerattdroite5 end
if player.timer >140-10 and player.timer <=160-15 then player.img = playerattdroite4 end
if player.timer >160-15 and player.timer <=180-20 then player.img = playerattdroite3 end 
if player.timer >180-20 and player.timer <=200-25 then player.img = playerattdroite2 end
if player.timer >200-25 and player.timer <=220-30 then player.img = playerattdroite1 end
if player.timer >220-30 then player.timer = 0 end
end
end
end
--defense
if pad:l() and v.x >=-0.5 and v.x <=0.5 then
player.statut = "defense"
if player.statut == "defense" and v.x >=-0.5 and v.x <=0.5 then
if player.jumpstate == "sol" then
v.x = 0
end
if player.direction=="gauche" then 
player.img = playerdefgauche             
end
 if player.direction=="droite" then 
player.img = playerdefdroite
end
end 
end

if not pad:r() and not pad:l() then 
player.statut = "false"
end

--Dplacement 
if player.statut ~= "defense" and player.jumpstate == "sol" or player.jumpstate == "en saut" or player.jumpstate == "retombe" then
player.x = player.x+v.x
end

--player
if player.marche == true and player.statut == "false" then
if player.direction=="gauche" then 
player.timer = player.timer-v.x
if player.timer >=0 and player.timer <=20 then player.img = playergauche1 end
if player.timer >20 and player.timer <=40 then player.img = playergauche2 end
if player.timer >40 and player.timer <=60 then player.img = playergauche4 end 
if player.timer >60 and player.timer <=80 then player.img = playergauche3 end 
if player.timer >80 and player.timer <=100 then player.img = playergauche1 end 
if player.timer >100 then player.timer = 0 end
end
if player.direction=="droite" then 
player.timer = player.timer+v.x
if player.timer >=0 and player.timer <=20 then player.img = playerdroite1 end
if player.timer >20 and player.timer <=40 then player.img = playerdroite2 end
if player.timer >40 and player.timer <=60 then player.img = playerdroite4 end 
if player.timer >60 and player.timer <=80 then player.img = playerdroite3 end 
if player.timer >80 and player.timer <=100 then player.img = playerdroite1 end 
if player.timer >100 then player.timer = 0 end
end
end
player.vitesse = 4
if player.marche == false and player.statut == "false" then
if player.direction=="gauche" then 
player.img = playergauche4          
end
if player.direction=="droite" then 
player.img = playerdroite4
end
end
if pad:square() and player.energie >=0 then
if player.direction=="gauche" then 
player.energie = player.energie +v.x/3
end
if player.direction=="droite" then 
player.energie = player.energie -v.x/3
end
if player.energie >=0 then
player.vitesse = 8
end
end

for a = 1,1 do
screen:fillRect(bouton[a].x,bouton[a].y,bouton[a].largeur,20,bouton[a].color)
screen:print(bouton[a].x+bouton[a].largeur/2-30/2,bouton[a].y+6,bouton[a].txt,noir)
end

screen:blit(player.x,player.y,player.img) 
screen:blit(0,0,light)

for a = 1,3 do
nuage[a].x = nuage[a].x+1+math.random(-0.1,1)
screen:blit (nuage[a].x,nuage[a].y,nua)
if nuage[a].x >=480+272 then
nuage[a].y = math.random(0,200-72)
nuage[a].x = 0-272
end
end

if pad:start() then dofile("game.lua") end

oldpad = pad
screen.flip()
--screen.waitVblankStart()
screen:clear()
end